local L = AceLibrary("AceLocale-2.2"):new("MageAnnounce")
local waterfall = AceLibrary("Waterfall-1.0")
local GameVersion, _, _ = GetBuildInfo()
------------ Slash Commands ------------
local options = { 
	type = 'group',
	desc = L["Options"],
	args = {
		menu = {
			type = "execute",
			name = L["Options Menu"],
			desc = L["Shows the Options Menu"],
			wfHidden = true,
			func = function()
					waterfall:Open('MageAnnounce')
				end
		},
		bgenable = {
			type = "toggle",
			name = L["Enable in BGs"],
			desc = L["Enable messages in Battlegrounds"],
			get = "IsShowInBGs",
			set = "ToggleShowInBGs",
		},
		spellops = {
			type = 'group',
			name = L["Spell Options"],
			desc = L["Show Spell Options"],
			args = {
				polymsg = { -- Options for Polymorph
					type = 'text',
					name = L['Poly Message'],
					desc = L['Message to be displayed when polymorphing'],
					usage = L["<Your message>"],
					order = 1,
					get = "GetPolyMessage",
					set = "SetPolyMessage",
				},
				polyparty = { 
					type = 'toggle',
					name = L['Show Polymorph Messages in Party'],
					desc = L['Toggles the display of polymorph messages in party chat'],
					order = 2,
					get = "IsShowPolyInParty",
					set = "ToggleShowPolyInParty",
				},
				polyraid = {
					type = 'toggle',
					name = L['Show Polymorph Messages in Raid'],
					desc = L['Toggles the display of polymorph messages in raid chat'],
					order = 3,
					get = "IsShowPolyInRaid",
					set = "ToggleShowPolyInRaid",
				},
				csmsg = { -- Options for Counter Spell
					type = 'text',
					name = L['Counterspell Message'],
					desc = L['Message to be displayed when counterspelling'],
					usage = L["<Your message>"],
					order = 4,
					get = "GetCSMessage",
					set = "SetCSMessage",
				},
				csparty = { 
					type = 'toggle',
					name = L['Show Counterspell Messages in Party'],
					desc = L['Toggles the display of counterspell messages in party chat'],
					order = 5,
					get = "IsShowCSInParty",
					set = "ToggleShowCSInParty",
				},
				csyraid = {
					type = 'toggle',
					name = L['Show Counterspell Messages in Raid'],
					desc = L['Toggles the display of counterspell messages in raid chat'],
					order = 6,
					get = "IsShowCSInRaid",
					set = "ToggleShowCSInRaid",
				},
				slowmsg = { -- Options for Slow
					type = 'text',
					name = L['Slow Message'],
					desc = L['Message to be displayed when slowing'],
					usage = L["<Your message>"],
					order = 7,
					get = "GetSlowMessage",
					set = "SetSlowMessage",
				},
				slowparty = { 
					type = 'toggle',
					name = L['Show Slow Messages in Party'],
					desc = L['Toggles the display of slow messages in party chat'],
					order = 8,
					get = "IsShowSlowInParty",
					set = "ToggleShowSlowInParty",
				},
				slowraid = {
					type = 'toggle',
					name = L['Show Slow Messages in Raid'],
					desc = L['Toggles the display of slow messages in raid chat'],
					order = 9,
					get = "IsShowSlowInRaid",
					set = "ToggleShowSlowInRaid",
				},
			},
		},
		portops = {
			type = 'group',
			name = L["Portal Options"],
			desc = L["Show Portal Options"],
			args = {
				portparty = {
					type = 'toggle',
					name = L['Show Portal Messages in Party'],
					desc = L['Toggles the display of portal messages in party chat'],
					order = 1,
					get = "IsShowPortInParty",
					set = "ToggleShowPortInParty",
				},
				portraid = {
					type = 'toggle',
					name = L['Show Portal Messages in Raid'],
					desc = L['Toggles the display of portal messages in raid chat'],
					order = 2,
					get = "IsShowPortInRaid",
					set = "ToggleShowPortInRaid",
				},
				shattmsg = { -- Options for Shattrath Portal
					type = 'text',
					name = L['Shattrath Portal Message'],
					desc = L['Message to be displayed when opening a Shattrath portal'],
					usage = L["<Your message>"],
					order = 3,
					get = "GetShattMessage",
					set = "SetShattMessage",
				},
				allyheader ={
					type = 'header',
					name = L["Alliance Portals"],
					order = 4,
				},
				swmsg = { -- Options for Stormwind Portal
					type = 'text',
					name = L['Stormwind Portal Message'],
					desc = L['Message to be displayed when opening a Stormwind portal'],
					usage = L["<Your message>"],
					order = 5,
					get = "GetSWMessage",
					set = "SetSWMessage",
				},
				ifmsg = { -- Options for Ironforge Portal
					type = 'text',
					name = L['Ironforge Portal Message'],
					desc = L['Message to be displayed when opening a Ironforge portal'],
					usage = L["<Your message>"],
					order = 6,
					get = "GetIFMessage",
					set = "SetIFMessage",
				},
				darnmsg = { -- Options for Darnassus Portal
					type = 'text',
					name = L['Darnassus Portal Message'],
					desc = L['Message to be displayed when opening a Darnassus portal'],
					usage = L["<Your message>"],
					order = 7,
					get = "GetDarnMessage",
					set = "SetDarnMessage",
				},
				exomsg = { -- Options for Exodar Portal
					type = 'text',
					name = L['Exodar Portal Message'],
					desc = L['Message to be displayed when opening a Exodar portal'],
					usage = L["<Your message>"],
					order = 8,
					get = "GetExoMessage",
					set = "SetExoMessage",
				},
				hordeheader ={
					type = 'header',
					name = L["Horde Portals"],
					order = 9,
				},
				orgmsg = { -- Options for Orgrimmar Portal
					type = 'text',
					name = L['Orgrimmar Portal Message'],
					desc = L['Message to be displayed when opening a Orgrimmar portal'],
					usage = L["<Your message>"],
					order = 10,
					get = "GetOrgMessage",
					set = "SetOrgMessage",
				},
				ucmsg = { -- Options for Undercity Portal
					type = 'text',
					name = L['Undercity Portal Message'],
					desc = L['Message to be displayed when opening a Undercity portal'],
					usage = L["<Your message>"],
					order = 11,
					get = "GetUCMessage",
					set = "SetUCMessage",
				},
				tbmsg = { -- Options for Thunder Bluff Portal
					type = 'text',
					name = L['Thunder Bluff Portal Message'],
					desc = L['Message to be displayed when opening a Thunder Bluff portal'],
					usage = L["<Your message>"],
					order = 12,
					get = "GetTBMessage",
					set = "SetTBMessage",
				},
				silvmsg = { -- Options for Silvermoon Portal
					type = 'text',
					name = L['Silvermoon Portal Message'],
					desc = L['Message to be displayed when opening a Silvermoon portal'],
					usage = L["<Your message>"],
					order = 13,
					get = "GetSilvMessage",
					set = "SetSilvMessage",
				},
			},
		},	
	},
}
------------ End Slash Commands ------------

MageAnnounce = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0")
MageAnnounce:RegisterChatCommand(L["Slash-Commands"], options)

------------ Defaults ------------
MageAnnounce:RegisterDB("MageAnnounceDB", "MageAnnounceDBPC")
MageAnnounce:RegisterDefaults("profile", {
	PolyMessage = L["Now Polymorphing %t"],
	CSMessage = L["Counterspelling %t"],
	SlowMessage = L["Slowing %t"],
	ShattMessage = L["Incoming Portal to Shattrath"], 
	SWMessage = L["Incoming Portal to Stormwind"], 
	IFMessage = L["Incoming Portal to Ironforge"], 
	DarnMessage = L["Incoming Portal to Darnassus"], 
	ExoMessage = L["Incoming Portal to Exodar"], 
	OrgMessage = L["Incoming Portal to Orgrimmar"],
	UCMessage = L["Incoming Portal to Undercity"],
	TBMessage = L["Incoming Portal to Thunder Bluff"],
	SilvMessage = L["Incoming Portal to Silvermoon"],
	ShowInBGs = true,
	ShowPolyInRaid = true, -- Polymorph
	ShowPolyInParty = true,
	ShowCSInRaid = true, -- Counterspell
	ShowCSInParty = true,
	ShowSlowInRaid = true, -- Slow
	ShowSlowInParty = true,
	ShowPortInParty = true, -- Portals
	ShowPortInRaid = true,
} )
------------ End Defaults ------------

------------ Main Code ------------
local IsInParty, IsInRaid
local WarnNum = 1

function MageAnnounce:OnEnable()
	waterfall:Register('MageAnnounce', 'aceOptions', options, 'title','MageAnnounce Options')
	self:RegisterEvent("UNIT_SPELLCAST_START")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("PARTY_MEMBERS_CHANGED")
	self:RegisterEvent("RAID_ROSTER_UPDATE")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	MageAnnounce:PARTY_MEMBERS_CHANGED()
	MageAnnounce:RAID_ROSTER_UPDATE()
end

function MageAnnounce:PARTY_MEMBERS_CHANGED() -- Check to see if in party
	if GetNumPartyMembers() > 0 then
		IsInParty = true
	else
		IsInParty = false
	end
end
function MageAnnounce:RAID_ROSTER_UPDATE() -- Check to see if in raid
	if GetNumRaidMembers() > 0 then
		IsInRaid = true
	else 
		IsInRaid = false
	end
end

function MageAnnounce:ZONE_CHANGED_NEW_AREA()
	local Zone = GetRealZoneText()
	self:Print(Zone)
	if Zone == ("Warsong Gulch" or "Alterac Valley" or "Arathi Basin" or "Eye of the Storm") then
		InBG = true
	end

end

function MageAnnounce:UNIT_SPELLCAST_START()
	local SpellCasting, _, _, _, _, _ = UnitCastingInfo("player")
	if SpellCasting then
		if strfind (SpellCasting, L["Polymorph"]) then
			if IsInParty and not IsInRaid and self.db.profile.ShowPolyInParty then -- Polymorph Party Messages
				SendChatMessage(self.db.profile.PolyMessage , "PARTY", nil, ""); 

			end
			if IsInRaid and self.db.profile.ShowPolyInRaid and WarnNum == 1 then -- Polymorph Raid Messages
				SendChatMessage(self.db.profile.PolyMessage , "RAID", nil, "");
				WarnNum = WarnNum + 1
			elseif WarnNum >= 2 then
				WarnNum = 1
			end
			if IsInBG and self.db.profile.ShowInBGs then -- Polymorph BG Messages
				SendChatMessage(self.db.profile.PolyMessage , "BATTLEGROUND", nil, ""); 

			end
		end
		if strfind(SpellCasting, L["Portal"]) then
			if IsInParty and not IsInRaid and self.db.profile.ShowPortInRaid then
				if SpellCasting == L["Portal: Shattrath"] then
					SendChatMessage(self.db.profile.ShattMessage, "PARTY", nil, ""); 
				end
				if SpellCasting == L["Portal: Stormwind"] then
					SendChatMessage(self.db.profile.SWMessage, "PARTY", nil, ""); 
				end
				if SpellCasting == L["Portal: Ironforge"] then
					SendChatMessage(self.db.profile.IFMessage, "PARTY", nil, ""); 
				end
				if SpellCasting == L["Portal: Darnassus"] then
					SendChatMessage(self.db.profile.DarnMessage, "PARTY", nil, ""); 
				end
				if SpellCasting == L["Portal: Exodar"] then
					SendChatMessage(self.db.profile.ExoMessage, "PARTY", nil, ""); 
				end
				if SpellCasting == L["Portal: Orgrimmar"] then
					SendChatMessage(self.db.profile.ExoMessage, "PARTY", nil, ""); 
				end
				if SpellCasting == L["Portal: Undercity"] then
					SendChatMessage(self.db.profile.ExoMessage, "PARTY", nil, ""); 
				end
				if SpellCasting == L["Portal: Thunder Bluff"] then
					SendChatMessage(self.db.profile.ExoMessage, "PARTY", nil, ""); 
				end
				if SpellCasting == L["Portal: Silvermoon"] then
					SendChatMessage(self.db.profile.ExoMessage, "PARTY", nil, ""); 
				end
			end
			if IsInRaid and self.db.profile.ShowPortInRaid and WarnNum == 1 then
				if SpellCasting == L["Portal: Shattrath"] then
					SendChatMessage(self.db.profile.ShattMessage, "RAID", nil, ""); 
				end
				if SpellCasting == L["Portal: Stormwind"] then
					SendChatMessage(self.db.profile.SWMessage, "RAID", nil, ""); 
				end
				if SpellCasting == L["Portal: Ironforge"] then
					SendChatMessage(self.db.profile.IFMessage, "RAID", nil, ""); 
				end
				if SpellCasting == L["Portal: Darnassus"] then
					SendChatMessage(self.db.profile.DarnMessage, "RAID", nil, ""); 
				end
				if SpellCasting == L["Portal: Exodar"] then
					SendChatMessage(self.db.profile.ExoMessage, "RAID", nil, ""); 
				end
				if SpellCasting == L["Portal: Orgrimmar"] then
					SendChatMessage(self.db.profile.ExoMessage, "RAID", nil, ""); 
				end
				if SpellCasting == L["Portal: Undercity"] then
					SendChatMessage(self.db.profile.ExoMessage, "RAID", nil, ""); 
				end
				if SpellCasting == L["Portal: Thunder Bluff"] then
					SendChatMessage(self.db.profile.ExoMessage, "RAID", nil, ""); 
				end
				if SpellCasting == L["Portal: Silvermoon"] then
					SendChatMessage(self.db.profile.ExoMessage, "RAID", nil, ""); 
				end
				WarnNum = WarnNum + 1
			elseif WarnNum >= 2 then
				WarnNum = 1
			end
			if IsInBG and self.db.profile.ShowInBGs then
				if SpellCasting == L["Portal: Shattrath"] then
					SendChatMessage(self.db.profile.ShattMessage, "BATTLEGROUND", nil, ""); 
				end
				if SpellCasting == L["Portal: Stormwind"] then
					SendChatMessage(self.db.profile.SWMessage, "BATTLEGROUND", nil, ""); 
				end
				if SpellCasting == L["Portal: Ironforge"] then
					SendChatMessage(self.db.profile.IFMessage, "BATTLEGROUND", nil, ""); 
				end
				if SpellCasting == L["Portal: Darnassus"] then
					SendChatMessage(self.db.profile.DarnMessage, "BATTLEGROUND", nil, ""); 
				end
				if SpellCasting == L["Portal: Exodar"] then
					SendChatMessage(self.db.profile.ExoMessage, "BATTLEGROUND", nil, ""); 
				end
				if SpellCasting == L["Portal: Orgrimmar"] then
					SendChatMessage(self.db.profile.ExoMessage, "BATTLEGROUND", nil, ""); 
				end
				if SpellCasting == L["Portal: Undercity"] then
					SendChatMessage(self.db.profile.ExoMessage, "BATTLEGROUND", nil, ""); 
				end
				if SpellCasting == L["Portal: Thunder Bluff"] then
					SendChatMessage(self.db.profile.ExoMessage, "BATTLEGROUND", nil, ""); 
				end
				if SpellCasting == L["Portal: Silvermoon"] then
					SendChatMessage(self.db.profile.ExoMessage, "BATTLEGROUND", nil, ""); 
				end
			end
		end
	end
end
function MageAnnounce:UNIT_SPELLCAST_SUCCEEDED(Caster, SpellName)
	if Caster == "player" then
		if strfind (SpellName, L["Counterspell"]) then
			if IsInParty and not IsInRaid and self.db.profile.ShowCSInParty then -- Counterspell Party Messages
				SendChatMessage(self.db.profile.CSMessage , "PARTY", nil, ""); 
			end
			if IsInRaid and self.db.profile.ShowCSInRaid then -- Counterspell Raid Messages
				SendChatMessage(self.db.profile.CSMessage , "RAID", nil, "");
			end
			if IsInBG and self.db.profile.ShowInBGs then -- Slow BG Messages
				SendChatMessage(self.db.profile.CSMessage , "BATTLEGROUND", nil, "");
			end
		end
		if SpellName == L["Slow"] then
			if IsInParty and not IsInRaid and self.db.profile.ShowSlowInParty then -- Slow Party Messages
				SendChatMessage(self.db.profile.SlowMessage , "PARTY", nil, ""); 

			end
			if IsInRaid and self.db.profile.ShowSlowInRaid then -- Slow Raid Messages
				SendChatMessage(self.db.profile.SlowMessage , "RAID", nil, "");
			end
			if IsInBG and self.db.profile.ShowInBGs then -- Slow BG Messages
				SendChatMessage(self.db.profile.SlowMessage , "BATTLEGROUND", nil, "");
			end
		end
	end
end
------------ End Main Code ------------

------------ Set Messages ------------
function MageAnnounce:GetPolyMessage() -- Set Polymorph Message
	return self.db.profile.PolyMessage
end
function MageAnnounce:SetPolyMessage(newValue)
	self.db.profile.PolyMessage = newValue
end

function MageAnnounce:GetCSMessage() -- Set Counterspell Message
	return self.db.profile.CSMessage
end
function MageAnnounce:SetCSMessage(newValue)
	self.db.profile.CSMessage = newValue
end

function MageAnnounce:GetSlowMessage() -- Set Slow Message
	return self.db.profile.SlowMessage
end
function MageAnnounce:SetSlowMessage(newValue)
	self.db.profile.SlowMessage = newValue
end

function MageAnnounce:GetShattMessage() -- Set Shattrath Portal Message
	return self.db.profile.ShattMessage
end

function MageAnnounce:SetShattMessage(newValue)
	self.db.profile.ShattMessage = newValue
end

function MageAnnounce:GetSWMessage() -- Set Stormwind Portal Message
	return self.db.profile.SWMessage
end
function MageAnnounce:SetSWMessage(newValue)
	self.db.profile.SWMessage = newValue
end

function MageAnnounce:GetIFMessage() -- Set Ironforge Portal Message
	return self.db.profile.IFMessage
end
function MageAnnounce:SetIFMessage(newValue)
	self.db.profile.IFMessage = newValue
end

function MageAnnounce:GetDarnMessage() -- Set Darnassus Portal Message
	return self.db.profile.DarnMessage
end
function MageAnnounce:SetDarnMessage(newValue)
	self.db.profile.DarnMessage = newValue
end

function MageAnnounce:GetExoMessage() -- Set Exodar Portal Message
	return self.db.profile.ExoMessage
end
function MageAnnounce:SetExoMessage(newValue)
	self.db.profile.ExoMessage = newValue
end

function MageAnnounce:GetOrgMessage() -- Set Ogrimmar Portal Message
	return self.db.profile.OrgMessage
end
function MageAnnounce:SetOrgMessage(newValue)
	self.db.profile.OrgMessage = newValue
end

function MageAnnounce:GetUCMessage() -- Set Undercity Portal Message
	return self.db.profile.UCMessage
end
function MageAnnounce:SetUCMessage(newValue)
	self.db.profile.UCMessage = newValue
end

function MageAnnounce:GetTBMessage() -- Set Thunder Bluff Portal Message
	return self.db.profile.TBMessage
end
function MageAnnounce:SetTBMessage(newValue)
	self.db.profile.TBMessage = newValue
end

function MageAnnounce:GetSilvMessage() -- Set Silvermoon Portal Message
	return self.db.profile.SilvMessage
end
function MageAnnounce:SetSilvMessage(newValue)
	self.db.profile.SilvMessage = newValue
end
------------ End Set Messages ------------

------------ Set Options ------------
function MageAnnounce:IsShowInBGs() -- Messages in BGs Toggle
	return self.db.profile.ShowInBGs
end
function MageAnnounce:ToggleShowInBGs()
	self.db.profile.ShowInBGs = not self.db.profile.ShowInBGs
end
------------------------------------------------------------------------
function MageAnnounce:IsShowPolyInParty() -- Polymorph in Party Message Toggle
	return self.db.profile.ShowPolyInParty
end
function MageAnnounce:ToggleShowPolyInParty()
	self.db.profile.ShowPolyInParty = not self.db.profile.ShowPolyInParty
end
function MageAnnounce:IsShowPolyInRaid() -- Polymorph in Raid Message Toggle
	return self.db.profile.ShowPolyInRaid
end
function MageAnnounce:ToggleShowPolyInRaid()
	self.db.profile.ShowPolyInRaid = not self.db.profile.ShowPolyInRaid
end
------------------------------------------------------------------------
function MageAnnounce:IsShowCSInParty() -- Counterspell in Party Message Toggle
	return self.db.profile.ShowCSInParty
end
function MageAnnounce:ToggleShowCSInParty()
	self.db.profile.ShowCSInParty = not self.db.profile.ShowCSInParty
end
function MageAnnounce:IsShowCSInRaid() -- Counterspell in Raid Message Toggle
	return self.db.profile.ShowCSInRaid
end
function MageAnnounce:ToggleShowCSInRaid()
	self.db.profile.ShowCSInRaid = not self.db.profile.ShowCSInRaid
end
------------------------------------------------------------------------
function MageAnnounce:IsShowSlowInParty() -- Slow in Party Message Toggle
	return self.db.profile.ShowSlowInParty
end
function MageAnnounce:ToggleShowSlowInParty()
	self.db.profile.ShowSlowInParty = not self.db.profile.ShowSlowInParty
end

function MageAnnounce:IsShowSlowInRaid() -- Slow in Raid Message Toggle
	return self.db.profile.ShowSlowInRaid
end
function MageAnnounce:ToggleShowSlowInRaid()
	self.db.profile.ShowSlowInRaid = not self.db.profile.ShowSlowInRaid
end
------------------------------------------------------------------------
function MageAnnounce:IsShowPortInParty() -- Portal in Party Message Toggle
	return self.db.profile.ShowPortInParty
end
function MageAnnounce:ToggleShowPortInParty()
	self.db.profile.ShowPortInParty = not self.db.profile.ShowPortInParty
end

function MageAnnounce:IsShowPortInRaid() -- Portal in Raid Message Toggle
	return self.db.profile.ShowPortInRaid
end
function MageAnnounce:ToggleShowPortInRaid()
	self.db.profile.ShowPortInRaid = not self.db.profile.ShowPortInRaid
end
------------ End Set Options ------------